
//
//
//
//
//
//
//
//
#include "sys/alt_stdio.h"
#include "altera_avalon_pio_regs.h"
#include "system.h"
#include "unistd.h"

#define PORTA_MOTOR				PORT_A_BASE
#define BOTOES					BOTOES_BASE
#define config_DDR(porta,dado)	IOWR_ALTERA_AVALON_PIO_DIRECTION(porta, dado)
#define entrada(porta)			IORD_ALTERA_AVALON_PIO_DATA(porta)
#define saida(porta,dado)		IOWR_ALTERA_AVALON_PIO_DATA(porta, dado)
#define HORARIO					0b10101100
#define ANTIHORARIO				0b10011100
#define PARADO					0b00001100

int botao_pressionado;

int main ()
{
	alt_putstr("Acionando o motor com o NIOS II\n\n");

	config_DDR (PORTA_MOTOR, 0b11111100);
	while (1)  {
	//
		//Testando os comandos dos botes...
		botao_pressionado = ((entrada (BOTOES) & 0b00010 ) == 0);
		if ( botao_pressionado) { //
			saida (PORTA_MOTOR, ANTIHORARIO);
			alt_printf ("O motor est girando no sentido antihorrio.\n");
			do
				botao_pressionado = ((entrada (BOTOES) & 0b00010 ) == 0);
			while (botao_pressionado); // Espera que...
			}

		botao_pressionado = ((entrada (BOTOES) & 0b01000 ) == 0);
		if ( botao_pressionado) { //
			saida (PORTA_MOTOR, HORARIO);
			alt_printf ("O motor est girando no sentido horrio.\n");
			do
				botao_pressionado = ((entrada (BOTOES) & 0b01000 ) == 0);
			while (botao_pressionado); // Espera que...

		}

		botao_pressionado = ((entrada (BOTOES) & 0b00100 ) == 0);
		if ( botao_pressionado) { //
			saida (PORTA_MOTOR, PARADO);
			alt_printf ("O motor est parado.\n");
			do
				botao_pressionado = ((entrada (BOTOES) & 0b00100 ) == 0);
			while (botao_pressionado); // Espera que...
		}

		usleep (200000);

	}


}
